﻿function Gadget() {
	this.content = document.getElementById('content');
	this.proportions = null;
	this.storageData = null;
	this.params = null;
	System.Gadget.settingsUI = "options.html";
	this.config = new Config();
	this.template = 'dock';
	this.init = function() {
		this.proportions = this.config.proportions || {w: '130px', h: '120px', undock_w: '400px', undock_h: '400px'};
		$('body').css({width: this.proportions.w, height: this.proportions.h});
		System.Gadget.onDock = function(){_this.setGadget(_this.proportions)};
		System.Gadget.onUndock = function(){_this.setGadget(_this.proportions)};
		System.Gadget.Flyout.file = "flyout.html";
		System.Gadget.onSettingsClosed = function(event) {
			if (event.closeAction == event.Action.commit) {
				$('.preloader').show();
				window.postMessage(null, "*");
			}		
		}
		this.content.onclick = function() {
			if (System.Gadget.docked) {
				System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
				_this.template = 'dock';
				window.postMessage(null, "*");				
				System.Gadget.Flyout.onShow = function() {
					_this.template = 'undock_flyout';
					System.Gadget.document.parentWindow.postMessage(null, "*");
				}
				System.Gadget.Flyout.onHide = function() {
					_this.setGadget(_this.proportions);
				}
			}			
		}
	}
	this.setGadget = function(proportions) {
		if (System.Gadget.docked) {
			$('body').css({width: proportions.w, height: proportions.h});
			with(background)	{
				style.width = proportions.w;
				style.height = proportions.h;
				src = "/images/bg_dock.png";
			}
			this.template = 'dock';
			window.postMessage(null, "*");
		}
		else if(!System.Gadget.docked) {
			$('body').css({width: proportions.undock_w, height: proportions.undock_h});
			with(background)	{
				style.width = proportions.undock_w;
				style.height = proportions.undock_h;
				src = "/images/background_undock.png";
			}
			this.template = 'undock';
			window.postMessage(null, "*");
		}
	}

	window.attachEvent('onmessage', function(e) {
		bgProc.getUTCTime(function() {
			bgProc.init(function(){ bgProc.checkVersion(
				true,
				function(){bgProc.getFrc(function() {
					if (!System.Gadget.Flyout.show) var o = document;
					else var o = System.Gadget.Flyout.document;	
					try {	
						var render = new Render(o, {city: bgProc.city, forecast: bgProc.forecast, params: bgProc.params, template: _this.template, dict: bgProc.dict, utc: bgProc.utc, isReloadApp: bgProc.isReloadApp});
					}catch(err) {}				
				});
				});	
			});
		});
	});
	
	var bgProc = new BgProc();
	var _this = this;
	this.init();
	$.support.cors = true;
	window.postMessage(null, "*");
}

function writeLog(str) {
		var log = document.getElementById('log');
		if (log) {
			//var content = log.innerHTML;
			//var now = new Date();
			//str = '<p>' + now.toString("dd.mm.yyyy hh:mm:ss")+' '+ strtype.toUpperCase() + ': ' + (typeof str != 'undefined'?str:'') + '</p>';
			//str = typeof str != 'undefined'?str:'';			
			log.innerHTML = str;
		}
}
